> For the complete documentation index, see [llms.txt](https://docs.umbraco.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.umbraco.com/umbraco-cms/13.latest/reference/management/models/template.md).

# Template

Represents a Template file.

* **Namespace:** `Umbraco.Cms.Core.Models`
* **Assembly:** `Umbraco.Core.dll`

All samples in this document will require references to the following dll:

* Umbraco.Core.dll

All samples in this document will require the following using statements:

```csharp
using Umbraco.Cms.Core.Models;
```

## Constructors

### new Template(IShortStringHelper shortStringHelper, string name, string alias)

Constructor for creating a new Template object. The necessary parameters include a short String Helper as an `IShortStringHelper`. The name and alias of the Template must be provided as `string` values.

## Properties

### .Alias

Gets the Alias of the File, which is the name without the extension.

```csharp
var template = new Template(shortStringHelper, "Page", "page");
return template.Alias;
```

### .IsMasterTemplate

Returns true if the template is used as a layout for other templates (that is, it has 'children')

```csharp
var template = new Template(shortStringHelper,"Page", "page");
return template.IsMasterTemplate;
```

### .MasterTemplateAlias

Returns the alias of the master template if one is set.

```csharp
var template = new Template(shortStringHelper, "Page", "page");
return template.MasterTemplateAlias;
```

### .MasterTemplateId

Returns the id of the master template if one is set.

```csharp
var template = new Template(shortStringHelper, "Page", "page");
return template.MasterTemplateId;
```

### .Name

Gets the Name of the File including extension.

```csharp
var template = new Template(shortStringHelper, "Page", "page");
return template.Name;
```

## Methods

### .SetMasterTemplate(ITemplate masterTemplate)

Sets the master template of the template.

```csharp
// Create a new template
var template = new Template(shortStringHelper, "Page", "page");
// Get a master template 
var masterTemplate = fileService.GetTemplate(1234);
// Set the master template to new created template
template.SetMasterTemplate(masterTemplate);
// Save the new template
fileService.SaveTemplate(template);
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.umbraco.com/umbraco-cms/13.latest/reference/management/models/template.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
